#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test = require("blue-tape");
// import * as sinon from 'sinon'
const clone_class_1 = require("./clone-class");
class FixtureClass {
    constructor(i, j) {
        this.i = i;
        this.j = j;
        //
    }
    static staticMethod(n) {
        this.staticNumber = n;
    }
    sum() {
        return this.i + this.j + this.constructor.staticNumber;
    }
}
const EXPECTED_NUMBER1 = 1;
const EXPECTED_NUMBER2 = 2;
test('cloneClass smoke testing', (t) => __awaiter(this, void 0, void 0, function* () {
    // tslint:disable-next-line:variable-name
    const NewClass1 = clone_class_1.cloneClass(FixtureClass);
    // tslint:disable-next-line:variable-name
    const NewClass2 = clone_class_1.cloneClass(FixtureClass);
    t.ok(NewClass1.prototype instanceof FixtureClass, 'should extend right');
    t.notEqual(NewClass1, NewClass2, 'NewClass1 should different with NewClass2');
    t.notEqual(NewClass1, FixtureClass, 'NewClass1 should different with FixtureClass');
    NewClass1.staticMethod(EXPECTED_NUMBER1);
    t.equal(NewClass1.staticNumber, EXPECTED_NUMBER1, 'should set static number to EXPECTED_NUMBER1');
    NewClass2.staticMethod(EXPECTED_NUMBER2);
    t.equal(NewClass2.staticNumber, EXPECTED_NUMBER2, 'should set static number to EXPECTED_NUMBER2');
    const nc1 = new NewClass1(EXPECTED_NUMBER1, EXPECTED_NUMBER2);
    const nc2 = new NewClass2(EXPECTED_NUMBER1, EXPECTED_NUMBER2);
    t.ok(nc1 instanceof FixtureClass, 'nc1 should instanceof FixtureClass');
    t.ok(nc1 instanceof NewClass1, 'nc1 should  instanceof NewClass1');
    t.equal(nc1.sum(), EXPECTED_NUMBER1 + EXPECTED_NUMBER1 + EXPECTED_NUMBER2, 'should sum right for 1 + 1 + 2');
    t.equal(nc2.sum(), EXPECTED_NUMBER2 + EXPECTED_NUMBER1 + EXPECTED_NUMBER2, 'should sum right for 2 + 1 + 2');
}));
test('instanceToClass smoke testing', (t) => __awaiter(this, void 0, void 0, function* () {
    const instance = new FixtureClass(1, 2);
    // tslint:disable-next-line:variable-name
    const SameFixtureClass = clone_class_1.instanceToClass(instance, FixtureClass);
    t.equal(SameFixtureClass, FixtureClass, 'should get back the same Class for its own instance');
    class ChildFixtureClass extends FixtureClass {
    }
    const anotherInstance = new ChildFixtureClass(3, 4);
    // tslint:disable-next-line:variable-name
    const AnotherFixtureClass = clone_class_1.instanceToClass(anotherInstance, FixtureClass);
    t.notEqual(AnotherFixtureClass, FixtureClass, 'should get back another Class for instance from its child class');
}));
//# sourceMappingURL=clone-class.spec.js.map